// todo: undo bindings, collision checks?

keyboard
	var
		client/client
		names[0]
		down[0]

	New(Client)
		client = Client
		client.keyboard = src

	proc
		Axis(Name, Positive, Negative)
			names[Name] = list()
			names[Name][Positive] = 1
			winset(client, "key_[Positive]",    "parent=macro; name=[Positive];    command=\".key-state \\\"[Positive]\\\" 1\"")
			winset(client, "key_[Positive]_up", "parent=macro; name=[Positive]+up; command=\".key-state \\\"[Positive]\\\" 0\"")
			if(Negative)
				names[Name][Negative] = -1
				winset(client, "key_[Negative]",    "parent=macro; name=[Negative];    command=\".key-state \\\"[Negative]\\\" 1\"")
				winset(client, "key_[Negative]_up", "parent=macro; name=[Negative]+up; command=\".key-state \\\"[Negative]\\\" 0\"")

		KeyState(Key, IsDown)
			if(IsDown) down |= Key
			else down -= Key

		Check(Name)
			for(var/key in (names[Name] & down)) . += names[Name][key]
			. = . && . / abs(.) || 0

client
	var keyboard/keyboard

	Move() return !keyboard && ..()

	verb/key_state(Key as text, IsDown as num)
		set name = ".key state", instant = TRUE
		keyboard.KeyState(Key, IsDown)