projectile
	parent_type = /entity
	icon = 'shapes128.dmi'
	icon_state = "oval"
	bounds = "16,16"
	bound_x = (128 - 16) / 2
	bound_y = (128 - 16) / 2
	transform = matrix(24/128, 0, 0, 0, 24/128, 0)

	var
		plane/shooter
		shooter_type
		damage

		velocity[]

		live = TRUE
		lifetime = 30

	New(Shooter)
		shooter = Shooter
		shooter_type = shooter.type
		damage = shooter.shot_damage
		SetCenter(shooter)
		PlaySound('shoot.wav')

		var image/i = image('shapes128.dmi', "oval", FLOAT_LAYER)
		i.transform *= 4/3
		i.color = shooter.shot_border
		underlays += i

		layer += rand() // to avoid z-fighting

		spawn(lifetime) Despawn()

	Update()
		if(!Translate(velocity))
			live = FALSE
			Despawn()

	Crossed(atom/movable/A)
		Hit(A)

	proc
		CanHit(atom/movable/A)
			return !istype(A, shooter_type) && istype(A, /plane)

		Hit(atom/movable/A)
			if(!(live && CanHit(A))) return
			live = FALSE
			A.Shot(src)
			Despawn()

		Despawn()
			del src

atom
	movable
		Crossed(atom/movable/A)
			if(istype(A, /projectile))
				var projectile/p = A
				p.Hit(src)

		proc
			Shot(projectile/P)