world
	fps = 60
	maxx = 50
	maxy = 50
	icon_size = 128
	view = "11x7"
	mob = /player_plane
	turf = /sky

entity
	density = FALSE

client
	mouse_pointer_icon = 'shapes128.dmi'
	control_freak = CONTROL_FREAK_ALL
//	perspective = EDGE_PERSPECTIVE

	New()
		. = ..()
		winset(src, ":window", "pos=0,0; size=99999x99999")
		winset(src, ":window", "is-maximized=true")
		winset(src, ":map", "zoom=0; letterbox=false")
		/*
		var screen_size = winget(src, ":window", "size")
		var screen_width = text2num(screen_size)
		var screen_height = text2num(copytext(screen_size, length("[screen_width]")+2))
		view = "[-round(screen_width / -TILE_WIDTH / 1.5)]x[-round(screen_height / -TILE_HEIGHT / 1.5)]"
		*/
		__ViewChanged()

	__ViewChanged()
		..()
		FixCamera()

	proc
		FixCamera()
			// Fix the centering of the camera (see ID:118071)
			pixel_x = !(ViewWidth()  % 2) && TILE_WIDTH  / 2
			pixel_y = !(ViewHeight() % 2) && TILE_HEIGHT / 2

atom
	icon = 'icons.dmi'

sky
	parent_type = /turf
	icon_state = "sky"

	New()
		..()
		if(prob(10))
			// movement reference
			var obj/o = new (src)
			o.icon = 'shapes128.dmi'
			o.icon_state = "oval"
			o.color = "maroon"
			o.pixel_x = rand(-64, 64)
			o.pixel_y = rand(-64, 64)
			o.transform *= randn(1, 5) / 128